package md

import "applet/app/db/model"

type ZhiosAcquisition struct {
	Uid string `json:"uid"`
	Mid string `json:"mid"`
	Id  string `json:"id"`
}
type ZhiosUserProfile struct {
	Uid string `json:"uid"`
	Mid string `json:"mid"`
}
type AcquisitionCfg struct {
	Id                string `json:"id"`
	Status            string `json:"status"`
	Time              int    `json:"time"`
	StartTime         string `json:"start_time"`
	EndTime           string `json:"end_time"`
	SuccessConditions struct {
		Register struct {
			Open string `json:"open"`
		} `json:"register"`
		TaobaoAuthorization struct {
			Open string `json:"open"`
		} `json:"taobao_authorization"`
		BindPhone struct {
			Open string `json:"open"`
		} `json:"bind_phone"`
		FirstOrder struct {
			Open   string `json:"open"`
			Day    string `json:"day"`
			Status string `json:"status"`
		} `json:"first_order"`
		SelfOrder struct {
			Open  string `json:"open"`
			Money string `json:"money"`
		} `json:"self_order"`
		OrderPay struct {
			Open  string `json:"open"`
			Money string `json:"money"`
		} `json:"order_pay"`
		OrderStatus struct {
			Open   string `json:"open"`
			Status string `json:"status"`
		} `json:"order_status"`
	} `json:"success_conditions"`
	RewardAccountDay string `json:"reward_account_day"`
	AdSetting        struct {
		Status string `json:"status"`
		AdData string `json:"ad_data"`
	} `json:"ad_setting"`
	RewardRule struct {
		DirectTime         string         `json:"direct_time"`
		IndirectTime       string         `json:"indirect_time"`
		DirectSuccess      string         `json:"direct_success"`
		IndirectSuccess    string         `json:"indirect_success"`
		InvitedReward      string         `json:"invited_reward"`
		DirectSuccessMax   string         `json:"direct_success_max"`
		IndirectSuccessMax string         `json:"indirect_success_max"`
		InvitedRewardMax   string         `json:"invited_reward_max"`
		RewardType         string         `json:"reward_type"`
		RewardCoinId       string         `json:"reward_coin_id"`
		NewRewardCoinId    string         `json:"new_reward_coin_id"`
		LvRewardList       []LvRewardList `json:"lv_reward_list"`
	} `json:"reward_rule"`
	ExtraRewardSetting struct {
		Status     string `json:"status"`
		RewardStep []struct {
			Number string `json:"number"`
			Money  string `json:"money"`
			Lv     string `json:"lv"`
		} `json:"reward_step"`
	} `json:"extra_reward_setting"`
	RankRule struct {
		Status                 string `json:"status"`
		ActivityCycle          string `json:"activity_cycle"`
		EndTime                string `json:"end_time"`
		RankData               string `json:"rank_data"`
		FirstAwardMoney        string `json:"first_award_money"`
		SecondAwardMoney       string `json:"second_award_money"`
		ThirdAwardMoney        string `json:"third_award_money"`
		FirstAwardExtendCount  string `json:"first_award_extend_count"`
		SecondAwardExtendCount string `json:"second_award_extend_count"`
		ThirdAwardExtendCount  string `json:"third_award_extend_count"`
	} `json:"rank_rule"`
	RankData string `json:"rank_data"`
}
type LvRewardList struct {
	Id                 string               `json:"id"`
	DirectSuccess      string               `json:"direct_success"`
	IndirectSuccess    string               `json:"indirect_success"`
	Name               string               `json:"name"`
	InvitedReward      string               `json:"invited_reward"`
	DirectSuccessMax   string               `json:"direct_success_max"`
	IndirectSuccessMax string               `json:"indirect_success_max"`
	InvitedRewardMax   string               `json:"invited_reward_max"`
	CoinList           []RewardRuleCoinList `json:"coin_list"`
}
type RewardRuleCoinList struct {
	CoinId             string `json:"coin_id"`
	DirectSuccess      string `json:"direct_success"`
	IndirectSuccess    string `json:"indirect_success"`
	InvitedReward      string `json:"invited_reward"`
	DirectSuccessMax   string `json:"direct_success_max"`
	IndirectSuccessMax string `json:"indirect_success_max"`
	InvitedRewardMax   string `json:"invited_reward_max"`
}
type User struct {
	Info    *model.User
	Profile *model.UserProfile
}
