package consume

import (
	"applet/app/cfg"
	"applet/app/db"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/rule/one_circles"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
)

func OneCirclesSignInCopyGreenEnergyConsume(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>OneCirclesSignInCopyGreenEnergyConsume>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	one_circles.Init(cfg.RedisAddr)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			err = handleOneCirclesSignInCopyGreenEnergy(res.Body)
			if err != nil {
				fmt.Println("OneCirclesSignInCopyGreenEnergyConsume_ERR:::::", err.Error())
			}
			//_ = res.Reject(false)
			err = res.Ack(true)
			fmt.Println("err ::: ", err)
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleOneCirclesSignInCopyGreenEnergy(msgData []byte) error {
	//1、解析mq中queue的数据结构体
	var msg *md.OneCirclesStructForSignIn
	err := json.Unmarshal(msgData, &msg)
	if err != nil {
		return err
	}

	engine := db.DBs[msg.MasterId]
	err = one_circles.HandleSettlementSignInGreenEnergy(engine, msg.MasterId, msg.Id, msg.Uid, msg.EndTime)
	fmt.Println("err::::", err)
	if err != nil {
		return err
	}
	return nil
}
