package svc

import (
	"applet/app/cfg"
	"applet/app/db"
	"applet/app/utils/cache"
	"applet/mall/utils"
	db2 "applet/super_cloud_issuance/db"
	"applet/super_cloud_issuance/enum"
	"applet/super_cloud_issuance/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/chain_transfer"
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/implement"
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/models"
	"fmt"
	"github.com/gin-gonic/gin"
	"time"
)

type DealSuperCloudIssuanceCallBackService struct {
	Context *gin.Context `json:"context"`
}

func (dealSuperCloudIssuanceCallBackService *DealSuperCloudIssuanceCallBackService) Set(c *gin.Context) { // set方法
	dealSuperCloudIssuanceCallBackService.Context = c
}

func (dealSuperCloudIssuanceCallBackService *DealSuperCloudIssuanceCallBackService) DealCallBack(c *gin.Context, req md.CallbackRequest) {
	//1、初始化云发单类
	cloudIssuanceService := CloudIssuanceService{}
	engine := db.DBs[dealSuperCloudIssuanceCallBackService.Context.GetString("mid")]

	//2、判断是否为群组消息
	if req.Data.IsGroup {
		//2、判断消息类型
		switch req.MessageType {
		case 9:
			dealSuperCloudIssuanceCallBackService.DealSourceGroupMessage(req.Data.FromGroup, req)

			//群聊文本消息
			bindId := dealSuperCloudIssuanceCallBackService.IsNeedDealGroupMessage(req.Data.FromGroup, req.Data.FromUser, req.RobotId)
			if bindId == 0 {
				return
			}
			//3、查询需转发的群
			superCloudIssuanceUserRobotBindFollowGroupDb := implement.NewSuperCloudIssuanceUserRobotBindFollowGroupDb(engine)
			cloudIssuanceUserRobotBindFollowGroups, err := superCloudIssuanceUserRobotBindFollowGroupDb.GetCloudIssuanceUserRobotBindFollowGroupByBindId(bindId)
			if err != nil {
				fmt.Println("DealCallBack_err::::", err.Error())
				return
			}
			cache.NewRedis(cfg.RedisAddr)
			cloudIssuanceUserRobotBindFollowDb := implement.NewSuperCloudIssuanceUserRobotBindFollowDb(engine)
			cloudIssuanceUserRobotBindFollow, err := cloudIssuanceUserRobotBindFollowDb.GetCloudIssuanceUserRobotBindFollow(bindId)
			for _, cloudIssuanceUserRobotBindFollowGroup := range cloudIssuanceUserRobotBindFollowGroups {
				fmt.Println(cloudIssuanceUserRobotBindFollowGroup)
				cloudIssuanceService.Set(nil, enum.RobotMacSendTextMethodName, "127.0.0.1")
				//转链
				if cloudIssuanceUserRobotBindFollow.Uid > 0 {
					args := map[string]string{
						"uid":       utils.IntToStr(cloudIssuanceUserRobotBindFollow.Uid),
						"platform":  "",
						"master_id": c.GetString("mid"),
						"content":   req.Data.Content,
					}
					utils.FilePutContents("cloud", utils.SerializeStr(args))
					chain := chain_transfer.TurnChain(MasterDb(c), db.Db, db2.ZhimengDb, args)
					utils.FilePutContents("cloud", utils.SerializeStr(chain))
					if chain.Count != "" {
						req.Data.Content = chain.Count
					}
				}
				utils.FilePutContents("cloud", req.Data.Content)
				err = cloudIssuanceService.RobotMacSendText(md.RobotMacSendTextRequest{
					RobotId: req.RobotId,
					WxId:    cloudIssuanceUserRobotBindFollowGroup.FollowChatRoomId,
					Content: req.Data.Content,
				})
				if err != nil {
					fmt.Println("DealCallBack_err::::", err.Error())
					return
				}
			}
			break
		case 10:
			dealSuperCloudIssuanceCallBackService.DealSourceGroupMessage(req.Data.FromGroup, req)

			//群聊图片消息
			bindId := dealSuperCloudIssuanceCallBackService.IsNeedDealGroupMessage(req.Data.FromGroup, req.Data.FromUser, req.RobotId)
			if bindId == 0 {
				return
			}
			//3、查询需转发的群
			superCloudIssuanceUserRobotBindFollowGroupDb := implement.NewSuperCloudIssuanceUserRobotBindFollowGroupDb(engine)
			cloudIssuanceUserRobotBindFollowGroups, err := superCloudIssuanceUserRobotBindFollowGroupDb.GetCloudIssuanceUserRobotBindFollowGroupByBindId(bindId)
			if err != nil {
				fmt.Println("DealCallBack_err::::", err.Error())
				return
			}
			for _, cloudIssuanceUserRobotBindFollowGroup := range cloudIssuanceUserRobotBindFollowGroups {
				cloudIssuanceService.Set(nil, enum.RobotMacSendRecvImageMethodName, "127.0.0.1")
				err = cloudIssuanceService.RobotMacSendRecvImage(md.RobotMacSendRecvImageRequest{
					RobotId: req.RobotId,
					WxId:    cloudIssuanceUserRobotBindFollowGroup.FollowChatRoomId,
					Content: req.Data.Content,
				})
				if err != nil {
					fmt.Println("DealCallBack_err::::", err.Error())
					return
				}
			}
			break
		case 11:
			dealSuperCloudIssuanceCallBackService.DealSourceGroupMessage(req.Data.FromGroup, req)

			//群聊视屏消息
			bindId := dealSuperCloudIssuanceCallBackService.IsNeedDealGroupMessage(req.Data.FromGroup, req.Data.FromUser, req.RobotId)
			if bindId == 0 {
				return
			}
			//3、查询需转发的群
			superCloudIssuanceUserRobotBindFollowGroupDb := implement.NewSuperCloudIssuanceUserRobotBindFollowGroupDb(engine)
			cloudIssuanceUserRobotBindFollowGroups, err := superCloudIssuanceUserRobotBindFollowGroupDb.GetCloudIssuanceUserRobotBindFollowGroupByBindId(bindId)
			if err != nil {
				fmt.Println("DealCallBack_err::::", err.Error())
				return
			}
			for _, cloudIssuanceUserRobotBindFollowGroup := range cloudIssuanceUserRobotBindFollowGroups {
				cloudIssuanceService.Set(nil, enum.RobotMacSendRecvViedoMethodName, "127.0.0.1")
				err = cloudIssuanceService.RobotMacSendRecvVideo(md.RobotMacSendRecvVideoRequest{
					RobotId: req.RobotId,
					WxId:    cloudIssuanceUserRobotBindFollowGroup.FollowChatRoomId,
					Content: req.Data.Content,
				})
				if err != nil {
					fmt.Println("DealCallBack_err::::", err.Error())
					return
				}
			}
			break
		}
	}
}

func (dealSuperCloudIssuanceCallBackService *DealSuperCloudIssuanceCallBackService) IsNeedDealGroupMessage(fromGroup, fromUser string, robotId int) (bindId int) {
	//查询 "发送群号" 是否被监听
	superCloudIssuanceUserRobotBindFollowDb := implement.NewSuperCloudIssuanceUserRobotBindFollowDb(db.DBs[dealSuperCloudIssuanceCallBackService.Context.GetString("mid")])
	cloudIssuanceUserRobotBindFollow, err := superCloudIssuanceUserRobotBindFollowDb.GetCloudIssuanceUserRobotBindFollowByChatRoomId(fromGroup, robotId)
	if err != nil {
		fmt.Println("IsNeedDealGroupMessage_Err:::::", err.Error())
		return
	}
	if cloudIssuanceUserRobotBindFollow == nil {
		return
	}

	//查询 "发送微信号" 是否被监听
	superCloudIssuanceUserRobotBindFollowUserDb := implement.NewSuperCloudIssuanceUserRobotBindFollowUserDb(db.DBs[dealSuperCloudIssuanceCallBackService.Context.GetString("mid")])
	cloudIssuanceUserRobotBindFollowUser, err := superCloudIssuanceUserRobotBindFollowUserDb.GetCloudIssuanceUserRobotBindFollowUserByWxId(fromUser)
	if err != nil {
		fmt.Println("IsNeedDealGroupMessage_Err:::::", err.Error())
		return
	}
	if cloudIssuanceUserRobotBindFollowUser == nil {
		return
	}

	bindId = cloudIssuanceUserRobotBindFollow.ActivateGroupId
	return
}

func (dealSuperCloudIssuanceCallBackService *DealSuperCloudIssuanceCallBackService) DealSourceGroupMessage(fromGroup string, req md.CallbackRequest) (err error) {
	engine := db.DBs[dealSuperCloudIssuanceCallBackService.Context.GetString("mid")]
	//查询 "发送群号" 是否为源头群
	superCloudIssuanceUserRobotWithActivateGroupDb := implement.NewSuperCloudIssuanceUserRobotWithActivateGroupDb(engine)
	superCloudIssuanceUserRobotWithActivateGroup, err := superCloudIssuanceUserRobotWithActivateGroupDb.GetSuperCloudIssuanceUserRobotWithActivateGroupByChatRoomId(fromGroup, req.RobotId)
	if err != nil {
		fmt.Println("DealSourceGroupMessage_Err:::::", err.Error())
		return
	}
	if superCloudIssuanceUserRobotWithActivateGroup == nil {
		return
	}
	activateGroupId := superCloudIssuanceUserRobotWithActivateGroup.Id

	superCloudIssuanceUserRobotBindSourceDb := implement.NewSuperCloudIssuanceUserRobotBindSourceDb(engine)
	superCloudIssuanceUserRobotBindSource, err := superCloudIssuanceUserRobotBindSourceDb.GetSuperCloudIssuanceUserRobotBindSource(activateGroupId)
	if err != nil {
		fmt.Println("DealSourceGroupMessage_Err:::::", err.Error())
		return
	}
	if superCloudIssuanceUserRobotBindSource != nil {
		superCloudIssuanceUserRobotBindSourceMessageLog := models.SuperCloudIssuanceUserRobotBindSourceMessageLog{
			ActivateGroupId: superCloudIssuanceUserRobotBindSource.ActivateGroupId,
			MessageType:     req.MessageType,
			Timestamp:       utils.StrToInt64(req.Data.Timestamp),
			Content:         req.Data.Content,
			CreateAt:        time.Now().Format("2006-01-02 15:04:05"),
			UpdateAt:        time.Now().Format("2006-01-02 15:04:05"),
		}

		superCloudIssuanceUserRobotBindSourceMessageLogDb := implement.NewSuperCloudIssuanceUserRobotBindSourceMessageLogDb(engine)
		_, err = superCloudIssuanceUserRobotBindSourceMessageLogDb.InsertSuperCloudIssuanceUserRobotBindSourceMessageLog(&superCloudIssuanceUserRobotBindSourceMessageLog)
		if err != nil {
			fmt.Println("DealSourceGroupMessage_Err:::::", err.Error())
			return err
		}
	}

	return
}
